/** \file
 * \brief Declaration of the UserParameter dialog 
 *
 * Programmierpraktikum Computergrafik (CGP): Aufgabe 1 - "Ui, OpenGL!"
 *
 * Created by Christian Vogelgsang <Vogelgsang@informatik.uni-erlangen.de>,
 * changed by Martin Aumueller <aumueller@uni-koeln.de>
 */

#ifndef USERPARAMETERDIALOG_H
#define USERPARAMETERDIALOG_H

#include <QDialog>

/*! \file ui_UserParameterDialog.h
 * \brief Ui::UserParameterDialog class generated by Qt Designer
 */

/*! \class Ui::UserParameterDialog
 * \brief UI class generated by Qt Designer
 */

/*! \class Ui_UserParameterDialog
 * \brief UI class generated by Qt Designer
 */

#include <ui_UserParameterDialog.h>

/*! The non-modal UserParameterDialog implements a tabbed dialog for adjusting some
  parameters of the render mode */

//! Non-modal UserParameter dialog
class UserParameterDialog : public QDialog
{
    // QT meta stuff
    Q_OBJECT

    public:

        //! Create a new UserParameter dialog
        UserParameterDialog(QWidget *parent=0);

        //! Destroy an UserParameter dialog
        virtual ~UserParameterDialog();

        //! Convert the internal state variables to the GUI representation
        void saveState();

        //! Transform GUI state to the internal state variables
        void restoreState();

    signals:
        // --- Signals ---
        void userParameter(double value);

    protected:

        // --- GUI Parts ---

        //! Store user shader parameter
        bool m_saveUserParameter;
        //! trigger update of saved data when showing the dialog
        void showEvent ( QShowEvent * event );

        Ui::UserParameterDialog ui;

   private slots:

        // ----- Slot Definitions -----

        //! restore saved values on pressing Cancel
        void reject();
};

#endif
